// Native_InheritanceDemo.cpp : Defines the entry point for the console application.
/*
________________________________________________________________
                      W O R K I N G   W I T H   I N H E R I T A N C E
                                             Ron Kessler
                                      Created 2/24/2017

Native Version so run with CTL-F5

This shows how to create a new class based upon a another class.
It is like creating a child class from a parent class.
We call them Base Classes and Derived Classes. The derived class
starts off as a copy of the base class then we can customize it
without starting from scratch.

Note: Child classes can inherit all NON-PRIVATE  members in the base class.
In the base, make things private if you don't want them inherited! 

Also, constructors/destructors are not inherited. 


So I create a Class called myShape as my base class.

Then I create a Rectangle class (child) that inherits all the members of the
base (parent) class.



_______________________________________________________________
*/

#include "stdafx.h"
#include <iostream>

using namespace std;

//---My Base class with two functions to get width and height
class myShape
	{
		public:
		void setWidth (int w)
			{
				width = w;
			}

		void setLength (int l)
			{
				length = l;
			}

		protected:				//this access modifier only lets derived classes inherit these
			int width;
			int length;
	};

//---My Derived class that inherits all the public or protected members of the class
class Rectangle : public myShape				// : public Shape	means Rectangle inherits FROM Shape.
	{
		public:										// this function will run as if it was inside Shape
			int getArea () const				//functions that do not change original values should be marked const
				{
					return ( width * length );
				}
	};

int main (void)
	{

		cout << "Now let's look at inheritance.\n\n";
		cout << "Assume your room is 15 feet wide and 17 feet.\n"
			"We can use a different (child) class to compute the area.\n\n";

		
		Rectangle Rect;					//instantiate a new rectangle class
		
		Rect.setWidth (15);			//notice I get to use the functions defined in Shape
		Rect.setLength (17);

		int sqFeet = Rect.getArea ();

		// Print the area of the object.
		cout << "The total area of your room is : " << sqFeet << "\n\n";

		return 0;
	}