// Native_PassByValOrRef.cpp : Defines the entry point for the console application.
/*
________________________________________________________

P A S S I N G   A R G U M E N T S   T O   F U N C T I O N S

Ron Kessler
Created 2/24/2017

Native version 
Use run to cursor to show how x changes

Updated 3/5/2017 Made it easier to see how value change using prompts
________________________________________________________
*/

#include "stdafx.h"
#include <iostream>
#include <string>

using namespace std;

//---function prototypes
void multiplyBy2 (int);			// option 1
void updateCart (int&);		// option 2

int main()
{
	//---simple assignment using the new Brace initialization style

	//int test (1.65);			//truncates to 1 but will compile
	//int test2{ 1.65 };		//won't compile because it results in loss of data

	//int x{ 1 };					//C++ 11 new initializer format    int{} = int {0} = int = 0 Prevents narrowing conversion.
	//int y{ x };
	//y = 2;

	//using strings
	string fname{ };
	fname = "Sandi";
	string& student{ fname };
	student = "Julie";



	int x{ 10 };
	int y{ x };
	int& numItems{ x };

	numItems = 25;









	//************REFERENCES**********
    
	//---using a reference with the & sign. The & comes AFTER the datatype
	int& xRef{ x };	// xRef = 1
	x = 15;				//assigns value of 15 to x
	xRef = 30;			//assigns value of 30 to x
	
	//So by using a reference I have another way of accessing the same piece of data.

	//Now, let's see why you want to know how to do this......
	//You can pass data to a function/method ByValue or ByReference. Pass by Val means we pass 
	//a copy of the data first and send the copy. That way, the original value is not changed.

	//Passing data ByRef means we are passing in the MEMORY location of that data, not the data
	//itself. In this case, the function CAN change the original value or work with it directly.












	//---OPTION 1: PASS BY VALUE
	

	int r{ 1 };					

	cout << "Calling ByVal: The value of r BEFORE the function call is " << r << +"\n\n";

	multiplyBy2 (r);			//the original value of r remains = 1 AFTER the function returns

	cout << "Calling ByVal: The value of r AFTER the function call is " << r << + "\n\n";














	//---OPTION 2: PASS BY REFERENCE. References MUST be initialized before being used

	

	int itemsInCart{0};
	cout << "Calling ByRef: The value of itemsInCart BEFORE the function call is " << itemsInCart << +"\n\n";

	updateCart (itemsInCart);	//the original value of itemsInCart is now = 20 AFTER the function returns
	
	cout << "Calling ByRef: The value of itemsInCart AFTER the function call is " << itemsInCart << + "\n\n";


	return 0;
}



//---option 1 BY VAL
void multiplyBy2 (int myParameter)				//by Value means the function works with a copy of the value passed in
	{
	myParameter = myParameter * 2;
	}





//---option 2 BY REF
void updateCart (int& items)		//by ref means the memory location the value is passed in
	{
		items += 1;
	}




